breed [nodes node]
nodes-own [node-id activity dailyproteinrate dailyproteinrequirement socialbout weight needprotein dailyenergyrate dailyenergyrequirement needenergy needtodrink waterintakeneeded dailydrinkrate socialtime socialtimeneeded needtosocial restingtime restingtimeneeded needtorest proteinintakerate energyintakerate category highestvalue] ;; activity 0: simulation start; activity 1 : at sleeping site (rest); activity 2: at protein site: (forage protein); activity 3: at water zone(drink); activity 4: at energysite (forage energy)
breed [links link]
links-own [strength]
patches-own [zone]
globals [simulations leader links-list clock adhesion-time mimetic-coefficient day dailypathlength socialbudget restingbudget foragingbudget movingbudget dead]

to setup
ca
set simulations 1
ask patch -1 1 [ set zone 1 
       set pcolor brown];; sleeping zone
ask patch 1 1  [ set zone 2 
      set pcolor green];; protein zone
ask patch 1 -1 [ set zone 3 
       set pcolor blue];; water zone
ask patch -1 -1 [ set zone 4 
      set pcolor grey];; energy zone
end

to simulate
ct
import-network
set clock 1
set day 0
set socialbudget 0
set restingbudget 0
set foragingbudget 0
set movingbudget 0
set adhesion-time 1
ask nodes [
  set color red
  set activity 0
  set dailyproteinrate  (dailyproteinrequirement - (random-normal 0.0008 0.0004 * weight * 12 * 60))
  set dailyenergyrate (dailyenergyrequirement - (0.05 * weight * 12 * 60))
  set dailydrinkrate (waterintakeneeded - (0.05 * weight * 12 * 60))
  set socialtime socialtimeneeded
  set restingtime restingtimeneeded
  set dailypathlength 0
  set socialbout 0
  ]
output-write "simulation " + simulations
output-print " "
dailyactivity
output-print "number of days"
output-print day  
output-print "category of individual with highestvalue"
output-print category-of max-one-of nodes [highestvalue]
output-print "values of highestvalue"
output-print value-from (max-one-of nodes [highestvalue]) [highestvalue]
file-open "highestvalue.doc"
file-type "sim"  + simulations + " : "
file-write day
file-write value-from (max-one-of nodes [highestvalue]) [highestvalue]
file-write category-of max-one-of nodes [highestvalue]
file-write node-id-of max-one-of nodes [highestvalue]
if value-from (max-one-of nodes [highestvalue]) [highestvalue] = value-from (max-one-of nodes [highestvalue]) [needprotein] [file-write "protein"]
if value-from (max-one-of nodes [highestvalue]) [highestvalue] = value-from (max-one-of nodes [highestvalue]) [needenergy] [file-write "energy"]
if value-from (max-one-of nodes [highestvalue]) [highestvalue] = value-from (max-one-of nodes [highestvalue]) [needtodrink] [file-write "water"]
if value-from (max-one-of nodes [highestvalue]) [highestvalue] = value-from (max-one-of nodes [highestvalue]) [needtorest] [file-write "rest"]
if value-from (max-one-of nodes [highestvalue]) [highestvalue] = value-from (max-one-of nodes [highestvalue]) [needtosocial] [file-write "social"]
file-print " "
file-close

ifelse simulations < simulations-number
  [set simulations simulations + 1  
    simulate]
  [stop simulate]
end

to dailyactivity
 ask nodes
 [set needprotein ((dailyproteinrequirement - dailyproteinrate)/ dailyproteinrequirement)
 set needenergy ((dailyenergyrequirement - dailyenergyrate)/ dailyenergyrequirement)
 set needtodrink ((waterintakeneeded - dailydrinkrate)/ waterintakeneeded)
 set needtosocial ((socialtimeneeded - socialtime)/ socialtimeneeded)
 set needtorest ((restingtimeneeded - restingtime)/ restingtimeneeded)
 if (needprotein >= needenergy) and (needprotein > needtodrink) and (needprotein >= needtosocial) and (needprotein >= needtorest)
  [set highestvalue needprotein]
  if (needenergy > needprotein) and (needenergy > needtodrink) and (needenergy >= needtosocial) and (needenergy >= needtorest)
  [set highestvalue needenergy]
  if (needtodrink >= needprotein) and (needtodrink >= needenergy) and (needtodrink >= needtosocial) and (needtodrink >= needtorest)
  [set highestvalue needtodrink]
  if (needtosocial > needprotein) and (needtosocial > needenergy) and (needtosocial > needtodrink) and (needtosocial > needtorest)
  [set highestvalue needtosocial]
  if (needtorest > needprotein) and (needtorest > needenergy) and (needtorest > needtodrink) and (needtorest >= needtosocial)
  [set highestvalue needtorest]]
 if (needprotein-of one-of nodes >= 1) or (needenergy-of one-of nodes >= 1) or (needtodrink-of one-of nodes >= 1) or (needtosocial-of one-of nodes >= 1) or (needtorest-of one-of nodes >= 1)
 [ stop dailyactivity]
 if day = 90 [stop dailyactivity]
set leader max-one-of nodes [highestvalue]
file-open "idleaderfrequency.doc"
file-write node-id-of leader
file-write category-of leader
file-print " "
file-close
ask leader
 [if highestvalue = needprotein
    [forageprotein]
  if highestvalue = needenergy
    [forageenergy]
  if highestvalue = needtodrink
  [drink]
if highestvalue = needtosocial
  [social]
if highestvalue = needtorest
  [rest]
       ]
ifelse clock > 720
  [night]
  [dailyactivity]
  
end

to forageprotein
 ask nodes
 [set needprotein ((dailyproteinrequirement - dailyproteinrate)/ dailyproteinrequirement)
 set needenergy ((dailyenergyrequirement - dailyenergyrate)/ dailyenergyrequirement)
 set needtodrink ((waterintakeneeded - dailydrinkrate)/ waterintakeneeded)
 set needtosocial ((socialtimeneeded - socialtime)/ socialtimeneeded)
 set needtorest ((restingtimeneeded - restingtime)/ restingtimeneeded)
 ]
 ask leader
[ifelse patch-here = patch 1 1
     [fd 0
     set dailyproteinrate (dailyproteinrate + proteinintakerate - (random-normal 0.0027 0.0013 * weight))
     set dailyenergyrate (dailyenergyrate - (random-normal 0.0696 0.0348 * weight))
     set restingtime (restingtime - (restingtimeneeded / 720))
     set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
     set socialtime (socialtime - (socialtimeneeded / 720))
     set activity 2
     set foragingbudget foragingbudget + 1
     set clock clock + 1
     ask nodes with [node-id != node-id-of leader]
         [fd 0
         set dailyproteinrate (dailyproteinrate + proteinintakerate - (random-normal 0.0027 0.0013 * weight))
         set dailyenergyrate (dailyenergyrate - (random-normal 0.0696 0.0348 * weight))
         set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
         set restingtime (restingtime - (restingtimeneeded / 720))
         set socialtime (socialtime - (socialtimeneeded / 720))]
     if dailyproteinrate < dailyproteinrequirement
     [forageprotein]
     ]
     [facexy 1 1
       fd 1
       set activity 2
       set clock clock + 1
       set movingbudget movingbudget + 1
       set dailyproteinrate (dailyproteinrate - random-normal 0.0027 0.0013 * weight)
       set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
       set dailyenergyrate (dailyenergyrate - (random-normal 0.0696 0.0348 * weight))
       set dailypathlength (dailypathlength + 25)
       set restingtime (restingtime - (restingtimeneeded / 720))
       set socialtime (socialtime - (socialtimeneeded / 720))
       ask nodes with [node-id != node-id-of leader]
         [    facexy 1 1
              fd 1
              set activity 2
              set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
              set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
              set dailyenergyrate (dailyenergyrate - (random-normal 0.0696 0.0348 * weight))
              set restingtime (restingtime - (restingtimeneeded / 720))
              set socialtime (socialtime - (socialtimeneeded / 720))
            ]
          ]
          ]
end

to forageenergy
 ask nodes
 [set needprotein ((dailyproteinrequirement - dailyproteinrate)/ dailyproteinrequirement)
 set needenergy ((dailyenergyrequirement - dailyenergyrate)/ dailyenergyrequirement)
 set needtodrink ((waterintakeneeded - dailydrinkrate)/ waterintakeneeded)
 set needtosocial ((socialtimeneeded - socialtime)/ socialtimeneeded)
 set needtorest ((restingtimeneeded - restingtime)/ restingtimeneeded)
  ]
 ask leader
[ifelse patch-here = patch -1 -1
     [fd 0
     set dailyenergyrate (dailyenergyrate + energyintakerate - (random-normal 0.0696 0.0348 * weight))
     set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
     set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
     set restingtime (restingtime - (restingtimeneeded / 720))
     set socialtime (socialtime - (socialtimeneeded / 720))
     set activity 4
     set foragingbudget foragingbudget + 1
     set clock clock + 1
     ask nodes with [node-id != node-id-of leader]
        [fd 0
        set dailyenergyrate (dailyenergyrate + energyintakerate - (random-normal 0.0696 0.0348 * weight))
        set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
        set restingtime (restingtime - (restingtimeneeded / 720))
        set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
        set socialtime (socialtime - (socialtimeneeded / 720))
        set activity 4]
       if dailyenergyrate < dailyenergyrequirement
       [forageenergy]
       ]
     [facexy -1 -1
       fd 1
       set activity 4
       set clock clock + 1
       set movingbudget movingbudget + 1
       set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
       set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
       set dailyenergyrate (dailyenergyrate - (random-normal 0.0696 0.0348 * weight))
       set dailypathlength (dailypathlength + 25)
       set restingtime (restingtime - (restingtimeneeded / 720))
       set socialtime (socialtime - (socialtimeneeded / 720))
       ask nodes with [node-id != node-id-of leader]
        [facexy -1 -1
       fd 1
       set activity 4
       set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
       set dailyenergyrate (dailyenergyrate - (random-normal 0.0696 0.0348 * weight))
       set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
       set restingtime (restingtime - (restingtimeneeded / 1440))
       set socialtime (socialtime - (socialtimeneeded / 720))
            ]
          ]
          ]
 end

to rest
 ask nodes
 [set needprotein ((dailyproteinrequirement - dailyproteinrate)/ dailyproteinrequirement)
 set needenergy ((dailyenergyrequirement - dailyenergyrate)/ dailyenergyrequirement)
 set needtodrink ((waterintakeneeded - dailydrinkrate)/ waterintakeneeded)
 set needtosocial ((socialtimeneeded - socialtime)/ socialtimeneeded)
 set needtorest ((restingtimeneeded - restingtime)/ restingtimeneeded)
  ]
 ask leader
     [fd 0
     set activity 1
     set clock clock + 1
     set restingbudget restingbudget + 1
     set restingtime restingtime + 1
     set socialtime (socialtime - (socialtimeneeded / 720))
     set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
     set dailyenergyrate (dailyenergyrate - (random-normal 0.025 0.012 * weight))
     set dailyproteinrate (dailyproteinrate - (random-normal 0.0008 0.0004 * weight))
     ask nodes with [node-id != node-id-of leader]
         [  fd 0
            set dailyenergyrate (dailyenergyrate - (random-normal 0.025 0.012 * weight))
            set dailyproteinrate (dailyproteinrate - (random-normal 0.0008 0.0004 * weight))
            set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
            set activity 1
            set restingtime restingtime + 1
            set socialtime (socialtime - (socialtimeneeded / 720))]
     ]
end

to social
 ask nodes
 [set needprotein ((dailyproteinrequirement - dailyproteinrate)/ dailyproteinrequirement)
 set needenergy ((dailyenergyrequirement - dailyenergyrate)/ dailyenergyrequirement)
 set needtodrink ((waterintakeneeded - dailydrinkrate)/ waterintakeneeded)
 set needtosocial ((socialtimeneeded - socialtime)/ socialtimeneeded)
 set needtorest ((restingtimeneeded - restingtime)/ restingtimeneeded)
  ]
 ask leader
 [fd 0
   set activity 5
   set socialbout socialbout + 1
   set clock clock + 1
   set socialbudget socialbudget + 1
   set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
   set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
   set dailyenergyrate (dailyenergyrate - (random-normal 0.07 0.035 * weight))
   set restingtime (restingtime - (restingtimeneeded / 720))
   set socialtime (socialtime + 1)
   ask nodes with [node-id != node-id-of leader]
     [fd 0
      set activity 5
      set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
      set dailydrinkrate (dailydrinkrate - (random-normal 0.059 0.029 * weight))
      set dailyenergyrate (dailyenergyrate - (random-normal 0.07 0.035 * weight))
      set restingtime (restingtime - (restingtimeneeded / 720))
      set socialtime (socialtime + 1)]
   if socialbout < 5 [social]
   set socialbout 0]
end

to drink
 ask nodes
 [set needprotein ((dailyproteinrequirement - dailyproteinrate)/ dailyproteinrequirement)
 set needenergy ((dailyenergyrequirement - dailyenergyrate)/ dailyenergyrequirement)
 set needtodrink ((waterintakeneeded - dailydrinkrate)/ waterintakeneeded)
 set needtosocial ((socialtimeneeded - socialtime)/ socialtimeneeded)
 set needtorest ((restingtimeneeded - restingtime)/ restingtimeneeded)
  ]
  ask leader
[ifelse patch-here = patch 1 -1
     [fd 0
     set activity 3
     set clock clock + 1
     set foragingbudget foragingbudget + 1
     set dailydrinkrate (dailydrinkrate + random-normal 50 25)
     set restingtime (restingtime - (restingtimeneeded / 720))
     set socialtime (socialtime - (socialtimeneeded / 720))
     set dailyenergyrate (dailyenergyrate - (random-normal 0.0696 0.0348 * weight))
     set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
     ask nodes with [node-id != node-id-of leader]
         [  fd 0
            set dailyenergyrate (dailyenergyrate - (random-normal 0.0696 0.0348 * weight))
            set dailydrinkrate (dailydrinkrate + random-normal 50 25)
            set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
            set restingtime (restingtime - (restingtimeneeded / 720))
            set socialtime (socialtime - (socialtimeneeded / 720))
            set activity 3
            set dailydrinkrate (dailydrinkrate + 1)]
      if dailydrinkrate < waterintakeneeded [drink]
      ]
     [facexy 1 -1
       fd 1
       set activity 3
       set clock clock + 1
       set movingbudget movingbudget + 1
       set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
       set dailyenergyrate (dailyenergyrate - (random-normal 0.0696 0.0348 * weight))
       set dailypathlength (dailypathlength + 25)
       set restingtime (restingtime - (restingtimeneeded / 720))
       set socialtime (socialtime - (socialtimeneeded / 720))
       ask nodes with [node-id != node-id-of leader]
         [    facexy 1 -1
              fd 1
              set activity 3
              set dailyproteinrate (dailyproteinrate - (random-normal 0.0027 0.0013 * weight))
              set dailyenergyrate (dailyenergyrate - (random-normal 0.07 0.035 * weight))
              set restingtime (restingtime - (restingtimeneeded / 720))
              set socialtime (socialtime - (socialtimeneeded / 720))
            ]
          ]]
end
       
to night
 ask nodes
 [set needprotein ((dailyproteinrequirement - dailyproteinrate)/ dailyproteinrequirement)
 set needenergy ((dailyenergyrequirement - dailyenergyrate)/ dailyenergyrequirement)
 set needtodrink ((waterintakeneeded - dailydrinkrate)/ waterintakeneeded)
 set needtosocial ((socialtimeneeded - socialtime)/ socialtimeneeded)
 set needtorest ((restingtimeneeded - restingtime)/ restingtimeneeded)
  ]
 ask nodes
 [ifelse patch-here = patch -1 1
     [fd 0
     set activity 1
     set restingtime restingtimeneeded
     set dailyenergyrate (dailyenergyrate - (random-normal 0.0012 0.0006 * weight * 720))
     set dailyproteinrate (dailyproteinrate - (random-normal 0.05 0.025 * weight * 720))
     ]
     [facexy -1 1
       fd 1
       set activity 11
       set dailyproteinrate (dailyproteinrate - (random-normal 0.07 0.035 * weight))
       set dailyenergyrate (dailyenergyrate - (random-normal 0.0027 0.0013 * weight))
       set dailypathlength (dailypathlength + 25)
       set restingtime (restingtime - (restingtimeneeded / 720))
       set socialtime (socialtime - 1)
                   ]]
output-print "day" + day     
output-print "movingbudget :"
output-print movingbudget
output-print "restingbudget :"
output-print restingbudget
output-print "foragingbudget :"
output-print foragingbudget
output-print "socialbudget :"
output-print socialbudget
file-open "activitybudget.doc"
file-write movingbudget
file-write foragingbudget
file-write socialbudget
file-write restingbudget
file-write dailypathlength
file-print " "
file-close
set clock 0
set movingbudget 0
set restingbudget 0
set foragingbudget 0
set socialbudget 0
set day day + 1
set dailypathlength 0
dailyactivity 
end

to import-network
  set-default-shape nodes "monkey"
  import-attributes
  
  import-links
end

;; This procedure reads in a files that contains node-specific attributes
;; including an unique identification number
to import-attributes
  ;; use CAREFULLY to ensure the file is
  ;; closed if there is an error and to notify
  ;; user of the error
  carefully [
    ;; This opens the file, so we can use it.
    file-open "attributes.txt"
    ;; Read in all the data in the file
    ;; data on the line is in this order:
    ;; node-id attribute1 attribute2
    while [not file-at-end?]
    [
      ;; this reads a single line into a three-item list
      let items read-from-string (word "[" file-read-line "]")
      create-custom-nodes 1 [  
        set node-id item 0 items
        set weight item 1 items
        set dailyproteinrequirement    item 2 items
        set dailyenergyrequirement   item 3 items
        set proteinintakerate   item 4 items
        set energyintakerate   item 5 items
        set waterintakeneeded   item 6 items
        set socialtimeneeded   item 7 items
        set restingtimeneeded   item 8 items
        set category item 9 items
      ]
    ]
  ]     
  ;; this is the error handling block of the carefully command
  [
    user-message (word "Error reading attributes.txt: " error-message)
  ]
  file-close
end

;; This procedure reads in a file that contains all the links
;; The file is simply 3 columns separated by spaces.  In this
;; example, the links are directed.  The first column contains
;; the node-id of the node originating the link.  The second
;; column the node-id of the node on the other end of the link.
;; The third column is the strength of the link.

to import-links
  carefully
  [
    ;; This opens the file, so we can use it.
    file-open "links.txt"
    ;; Read in all the data in the file
    while [not file-at-end?]
    [
      ;; this reads a single line into a three-item list
      let items read-from-string (word "[" file-read-line "]")
      ask get-node (item 0 items)
      [ 
        __create-link-to get-node (item 1 items)
          [ set label item 2 items ]
      ]
    ] 
  ]
  ;; this is the error handling block of the carefully command
  [
    user-message (word "Error reading links.txt: " error-message)
  ]
  file-close
end

;; Helper procedure for looking up a node by node-id.
to-report get-node [id]
  report one-of nodes with [node-id = id]
end
@#$#@#$#@
GRAPHICS-WINDOW
303
10
601
329
1
1
96.0
1
10
1
1
1
0
1
1
1
-1
1
-1
1

CC-WINDOW
5
592
978
687
Command Center
0

BUTTON
11
24
74
57
NIL
setup
NIL
1
T
OBSERVER
T
NIL

MONITOR
610
15
683
64
NIL
simulations
3
1

MONITOR
740
15
797
64
NIL
clock
3
1

BUTTON
100
26
177
59
NIL
simulate
NIL
1
T
OBSERVER
T
NIL

SLIDER
11
76
183
109
simulations-number
simulations-number
0
100
50
1
1
NIL

OUTPUT
304
342
602
578

MONITOR
797
15
895
64
NIL
dailypathlength
3
1

MONITOR
683
15
740
64
NIL
day
3
1

MONITOR
610
63
702
112
NIL
movingbudget\n
3
1

MONITOR
701
63
791
112
NIL
restingbudget
3
1

MONITOR
790
63
888
112
NIL
foragingbudget
3
1

MONITOR
887
63
969
112
NIL
socialbudget
3
1

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

monkey
false
0
Polygon -7500403 true true 87 267 106 290 145 292 157 288 175 292 209 292 207 281 190 276 174 277 156 271 154 261 157 245 151 230 156 221 171 209 214 165 231 171 239 171 263 154 281 137 294 136 297 126 295 119 285 105 241 145 240 120 270 120 282 124 285 75 270 60 240 60 226 72 225 75 208 88 180 105 151 107 119 117 84 139 61 175 57 210 65 231 79 253 60 255 45 240 30 210 15 165 30 105 45 75 75 60 105 60 135 75 135 60 90 45 45 60 15 105 0 165 30 240 60 270
Polygon -16777216 true false 267 85 279 84 285 92 276 95
Line -16777216 false 253 119 266 124
Line -16777216 false 278 110 278 116
Line -16777216 false 149 229 135 211
Line -16777216 false 134 211 115 207
Line -16777216 false 117 207 106 211
Line -16777216 false 91 268 131 290
Line -16777216 false 220 82 213 79
Line -16777216 false 286 126 294 128
Line -16777216 false 193 284 206 285

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.1.5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
